;------------------------------------------------------
; Sol_Asm assembler core
; Copyright (c) 2004-2005, Bogdan Valentin Ontanu.
; All rights reserved.
;------------------------------------------------------


;=================================
; Parameters
;=================================

;--------------------------------
;types defined
;--------------------------------
PAR_TYPE_INVALID		EQU	0
PAR_TYPE_IMEDIATE		EQU	1
PAR_TYPE_REGISTER		EQU	2
PAR_TYPE_REG_INDIRECT		EQU	3
PAR_TYPE_MEM_INDIRECT		EQU	4
PAR_TYPE_MODRM			EQU	5
PAR_TYPE_STRING			EQU	6

PARAM_STRU STRUC
	par_type		dd	?
	par_value		dd	?
	par_size		dd	?	;8,16,32,64,128bits
	par_tkn_start		dd	?
	par_tkn_size		dd	?
ENDS

.data
	param_crt	dd	-1
	param_count	dd	-1

.data?
	;----------------------------
	; setup by "byte ptr" stuff
	;----------------------------
	flag_ptr	dd	?
	flag_byte	dd	?
	flag_word	dd	?
	flag_dword	dd	?


	;------------------------
	;first 2 params ;)
	;------------------------

	par_base0:

	par1_type			dd	?
	par1_value			dd	?
	par1_size			dd	?

	par1_token_size		dd	?
	par1_token_start	dd	?

	par2_type			dd	?
	par2_value			dd	?
	par2_size			dd	?

	par2_token_size		dd	?
	par2_token_start	dd	?

	PARAM_MAX	EQU	64

	par_base2	PARAM_STRU	PARAM_MAX dup (<?>)

.code

;---------------------------------
; We are reading parameter(s)
;---------------------------------
On_Mode_Get_Param PROC
	USES	esi,edi
	ARG	@@token_start,@@token_size:dword

	ODS1	<"+++ON Mode Get Params">

	ret
ENDP
