;------------------------------------------------------
; Sol_Asm assembler core
; Copyright (c) 2004-2005, Bogdan Valentin Ontanu.
; All rights reserved.
;------------------------------------------------------


;==================================
; Some tokens are quoted
;==================================
On_Have_Token_String PROC
	USES	esi,edi
	ARG	@@token_start,@@token_size:dword

	ODS1	<"On Have Token String">

	Call	Str_Copy_Nr,[@@token_start],offset sz_tmp1,[@@token_size]
	ODS	<offset sz_tmp1>

	.IF [parse_mode]==P2_MODE_DEFINE_B
		;-----------------------------
		; store this string sequence
		;-----------------------------
		mov	esi,[@@token_start]
		inc	esi

		mov	edi,[lp_out_buff]
		add	edi,[out_crt]

		mov	ecx,[@@token_size]
		sub	ecx,2			;compensate for 2 quotes
		.IF ZERO?
			Call	Print_Error,offset sz_err_004,[@@token_start],[@@token_size]
			ret
		.ENDIF

		;-----------------------
		; store loop
		;-----------------------
		@@loop_char:
			mov	al,byte ptr [esi]
			mov	byte ptr [edi],al

			inc	[out_crt]
			inc	[addr_crt]
			inc	edi
			inc	esi
			dec	ecx
			jnz	@@loop_char
	.ELSE
		;--------------------------------
		;can not get a string here
		;--------------------------------
		Call	Print_Error,offset sz_err_005,[@@token_start],[@@token_size]
		ret
		
	.ENDIF

	ret
ENDP



